# all files / ol/structs/ lrucache.js

26.58% Statements 21/79
16.67% Branches 2/12
7.14% Functions 1/14
26.58% Lines 21/79

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161
    162
    163
    164
    165
    166
    167
    168
    169
    170
    171
    172
    173
    174
    175
    176
    177
    178
    179
    180
    181
    182
    183
    184
    185
    186
    187
    188
    189
    190
    191
    192
    193
    194
    195
    196
    197
    198
    199
    200
    201
    202
    203
    204
    205
    206
    207
    208
    209
    210
    211
    212
    213
    214
    215
    216
    217
    218
    219
    220
    2211×

    1×

    1×

    2×

    2×

    2×

    2×

    2×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

     goog.provide('ol.structs.LRUCache');

    goog.require('ol.asserts');

    /**
     * Implements a Least-Recently-Used cache where the keys do not conflict with
     * Object's properties (e.g. 'hasOwnProperty' is not allowed as a key). Expiring
     * items from the cache is the responsibility of the user.
     * @constructor
     * @struct
     * @template T
     * @param {number=} opt_highWaterMark High water mark.
     */
    ol.structs.LRUCache = function(opt_highWaterMark) {

      /**
       * @type {number}
       */
      this.highWaterMark = opt_highWaterMark !== undefined ? opt_highWaterMark : 2048;

      /**
       * @private
       * @type {number}
       */
      this.count_ = 0;

      /**
       * @private
       * @type {!Object.<string, ol.LRUCacheEntry>}
       */
      this.entries_ = {};

      /**
       * @private
       * @type {?ol.LRUCacheEntry}
       */
      this.oldest_ = null;

      /**
       * @private
       * @type {?ol.LRUCacheEntry}
       */
      this.newest_ = null;

    };

    /**
     * @return {boolean} Can expire cache.
     */
    ol.structs.LRUCache.prototype.canExpireCache = function() {
      return this.getCount() > this.highWaterMark;
    };

    /**
     * FIXME empty description for jsdoc
     */
    ol.structs.LRUCache.prototype.clear = function() {
      this.count_ = 0;
      this.entries_ = {};
      this.oldest_ = null;
      this.newest_ = null;
    };

    /**
     * @param {string} key Key.
     * @return {boolean} Contains key.
     */
    ol.structs.LRUCache.prototype.containsKey = function(key) {
      return this.entries_.hasOwnProperty(key);
    };

    /**
     * @param {function(this: S, T, string, ol.structs.LRUCache): ?} f The function
     *     to call for every entry from the oldest to the newer. This function takes
     *     3 arguments (the entry value, the entry key and the LRUCache object).
     *     The return value is ignored.
     * @param {S=} opt_this The object to use as `this` in `f`.
     * @template S
     */
    ol.structs.LRUCache.prototype.forEach = function(f, opt_this) {
      var entry = this.oldest_;
      while (entry) {
        f.call(opt_this, entry.value_, entry.key_, this);
        entry = entry.newer;
      }
    };

    /**
     * @param {string} key Key.
     * @return {T} Value.
     */
    ol.structs.LRUCache.prototype.get = function(key) {
      var entry = this.entries_[key];
      ol.asserts.assert(entry !== undefined,
          15); // Tried to get a value for a key that does not exist in the cache
      if (entry === this.newest_) {
        return entry.value_;
      } else if (entry === this.oldest_) {
        this.oldest_ = /** @type {ol.LRUCacheEntry} */ (this.oldest_.newer);
        this.oldest_.older = null;
      } else {
        entry.newer.older = entry.older;
        entry.older.newer = entry.newer;
      }
      entry.newer = null;
      entry.older = this.newest_;
      this.newest_.newer = entry;
      this.newest_ = entry;
      return entry.value_;
    };

    /**
     * @return {number} Count.
     */
    ol.structs.LRUCache.prototype.getCount = function() {
      return this.count_;
    };

    /**
     * @return {Array.<string>} Keys.
     */
    ol.structs.LRUCache.prototype.getKeys = function() {
      var keys = new Array(this.count_);
      var i = 0;
      var entry;
      for (entry = this.newest_; entry; entry = entry.older) {
        keys[i++] = entry.key_;
      }
      return keys;
    };

    /**
     * @return {Array.<T>} Values.
     */
    ol.structs.LRUCache.prototype.getValues = function() {
      var values = new Array(this.count_);
      var i = 0;
      var entry;
      for (entry = this.newest_; entry; entry = entry.older) {
        values[i++] = entry.value_;
      }
      return values;
    };

    /**
     * @return {T} Last value.
     */
    ol.structs.LRUCache.prototype.peekLast = function() {
      return this.oldest_.value_;
    };

    /**
     * @return {string} Last key.
     */
    ol.structs.LRUCache.prototype.peekLastKey = function() {
      return this.oldest_.key_;
    };

    /**
     * @return {T} value Value.
     */
    ol.structs.LRUCache.prototype.pop = function() {
      var entry = this.oldest_;
      delete this.entries_[entry.key_];
      if (entry.newer) {
        entry.newer.older = null;
      }
      this.oldest_ = /** @type {ol.LRUCacheEntry} */ (entry.newer);
      if (!this.oldest_) {
        this.newest_ = null;
      }
      --this.count_;
      return entry.value_;
    };

    /**
     * @param {string} key Key.
     * @param {T} value Value.
     */
    ol.structs.LRUCache.prototype.replace = function(key, value) {
      this.get(key);  // update `newest_`
      this.entries_[key].value_ = value;
    };

    /**
     * @param {string} key Key.
     * @param {T} value Value.
     */
    ol.structs.LRUCache.prototype.set = function(key, value) {
      ol.asserts.assert(!(key in this.entries_),
          16); // Tried to set a value for a key that is used already
      var entry = /** @type {ol.LRUCacheEntry} */ ({
        key_: key,
        newer: null,
        older: this.newest_,
        value_: value
      });
      if (!this.newest_) {
        this.oldest_ = entry;
      } else {
        this.newest_.newer = entry;
      }
      this.newest_ = entry;
      this.entries_[key] = entry;
      ++this.count_;
    };